import {
  csvParse,
  select,
  min,
  max,
  extent,
  group,
  flatGroup,
  rollup,
  flatRollup,
  sum,
  bin,
} from 'd3';
import { combine } from './combine.js'
import { filter } from './filter.js'


export const viz = (
  container,
  { state, setState }
) => {
  
  select(container)
    .selectAll('pre')
    .data([null])
    .join('pre')
    .text(JSON.stringify(state.data, null, 2));
 
  // state.data could be:
  // * undefined
  // * 'LOADING'
  // * An array of objects
  let { data } = state;

  if (data === undefined) {
    setState((state) => ({
      ...state,
      data: 'LOADING',
    }));
    fetch('https://raw.githubusercontent.com/flanagancarlie/social-media-isp-proposal/main/data.csv')
      .then((response) => response.text())
      .then((csvString) => {
        let data = csvParse(csvString);
      	data = filter(data);
        for (let d of data) {
					d = combine(d);      
        }
      
//         data = 
//           flatGroup(
//             data,
//             (d) => d.Q3
//           ).map(([key, value]) => ({
//             age_question: key,
//             responses_per_age: value.length,
//           }));
        // let sortedSummary = summary.slice().sort((a, b) => d3.descending(a.responses_per_age, b.responses_per_age))
        // console.log(sortedSummary)
      
        setState((state) => ({
          ...state,
          data,
        }));
      });
  }
};
